{$UNDEF DEBUG}

unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, FileCtrl, CheckLst, jpeg, Psock, NMsmtp, NMpop3,
  ComCtrls;

type
  TfrmMain = class(TForm)
    Panel1: TPanel;
    btnExit: TButton;
    gbStart: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    btnNext: TButton;
    Label4: TLabel;
    Label5: TLabel;
    gbStep1: TGroupBox;
    btnBack1: TButton;
    dlbDirectory: TDirectoryListBox;
    dcbDrive: TDriveComboBox;
    cbScanAll: TCheckBox;
    lblDirectory: TLabel;
    gbStep2: TGroupBox;
    gbStep3: TGroupBox;
    btnNext2: TButton;
    btnBack2: TButton;
    btnNext1: TButton;
    cbSMTP: TComboBox;
    Label16: TLabel;
    gbStep4: TGroupBox;
    gbStep5: TGroupBox;
    gbIdentity: TGroupBox;
    Label17: TLabel;
    cbName: TComboBox;
    Label18: TLabel;
    cbCompany: TComboBox;
    Label19: TLabel;
    cbEmail: TComboBox;
    gbFinish: TGroupBox;
    Label24: TLabel;
    Label25: TLabel;
    Label26: TLabel;
    Image1: TImage;
    Label22: TLabel;
    Label29: TLabel;
    Image3: TImage;
    Image2: TImage;
    Label28: TLabel;
    cbHideAppNames: TCheckBox;
    Mail: TNMSMTP;
    clbApps: TCheckListBox;
    Label32: TLabel;
    eUserID: TEdit;
    DelphiBanner: TImage;
    Label23: TLabel;
    Label27: TLabel;
    Label33: TLabel;
    Label34: TLabel;
    Label35: TLabel;
    cbAnonymous: TCheckBox;
    GroupBox1: TGroupBox;
    rbBorland: TRadioButton;
    rbSelf: TRadioButton;
    cbSelf: TComboBox;
    btnInfo: TButton;
    gbInfo: TGroupBox;
    Label6: TLabel;
    Label36: TLabel;
    mDirs: TMemo;
    mFiles: TMemo;
    btnBack6: TButton;
    Label37: TLabel;
    Label38: TLabel;
    Label39: TLabel;
    Label40: TLabel;
    Label41: TLabel;
    BCBBanner: TImage;
    BannerTimer: TTimer;
    Image4: TImage;
    LinuxBanner: TImage;
    btnCheckSelected: TButton;
    btnUncheckSelected: TButton;
    POP: TNMPOP3;
    reFinalResults: TRichEdit;
    reResults: TRichEdit;
    btnBack7: TButton;
    procedure dlbDirectoryChange(Sender: TObject);
    procedure btnExitClick(Sender: TObject);
    procedure btnNextClick(Sender: TObject);
    procedure btnBack1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure cbScanAllClick(Sender: TObject);
    procedure btnNext1Click(Sender: TObject);
    procedure btnBack2Click(Sender: TObject);
    procedure btnSendToClipBoardClick(Sender: TObject);
    procedure btnBack3Click(Sender: TObject);
    procedure btnNext2Click(Sender: TObject);
    procedure cbAnonymousClick(Sender: TObject);
    procedure btnBack4Click(Sender: TObject);
    procedure btnNext3Click(Sender: TObject);
    procedure btnNext4Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Image2Click(Sender: TObject);
    procedure Image3Click(Sender: TObject);
    procedure MailAttachmentNotFound(Filename: String);
    procedure MailAuthenticationFailed(var Handled: Boolean);
    procedure MailConnect(Sender: TObject);
    procedure MailConnectionFailed(Sender: TObject);
    procedure MailConnectionRequired(var Handled: Boolean);
    procedure MailDisconnect(Sender: TObject);
    procedure MailEncodeEnd(Filename: String);
    procedure MailEncodeStart(Filename: String);
    procedure MailFailure(Sender: TObject);
    procedure MailHeaderIncomplete(var handled: Boolean;
      hiType: Integer);
    procedure MailHostResolved(Sender: TComponent);
    procedure MailInvalidHost(var Handled: Boolean);
    procedure MailMailListReturn(MailAddress: String);
    procedure MailPacketSent(Sender: TObject);
    procedure MailRecipientNotFound(Recipient: String);
    procedure MailSendStart(Sender: TObject);
    procedure MailStatus(Sender: TComponent; Status: String);
    procedure MailSuccess(Sender: TObject);
    procedure clbAppsMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure gbStep2MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure btnSendToClipBoard2Click(Sender: TObject);
    procedure btnBack5Click(Sender: TObject);
    procedure btnNext5Click(Sender: TObject);
    procedure Image1Click(Sender: TObject);
    procedure dlbDirectoryClick(Sender: TObject);
    procedure DelphiBannerClick(Sender: TObject);
    procedure btnInfoClick(Sender: TObject);
    procedure btnBack6Click(Sender: TObject);
    procedure BannerTimerTimer(Sender: TObject);
    procedure BCBBannerClick(Sender: TObject);
    procedure Image4Click(Sender: TObject);
    procedure LinuxBannerClick(Sender: TObject);
    procedure btnCheckSelectedClick(Sender: TObject);
    procedure btnUncheckSelectedClick(Sender: TObject);
    procedure POPAuthenticationNeeded(var Handled: Boolean);
    procedure btnBack7Click(Sender: TObject);
  private
    { Private declarations }
    ResList : TStringList;
    Excludes : TStringList;
    Files : TStringList;
    DFM : TStringList;
    SkippedFiles : TStringList;
    SkippedDirs : TStringList;
    Results : TStringList;
    hProcess : THandle;
    SystemDrive : Char;
    SerialNumber : DWORD;
    DriveSpace : Int64;
    RegisteredOwner : String;
    procedure SetupExcludes;
    procedure FindEmailInfo;
    function GetResourceNames : Integer;
    function GetResourceFormFile(List: TStrings; const FormName, FileName: String) : Boolean;
    procedure GetResourceHeader(var ResourceHeader: String; const FormName: String; const FileSize: Integer);
    function OpenResource(const FileName : String) : Boolean;
    procedure TerminateInternalProcess;
    function ExcludeDir(Dir : String) : Boolean;
    function ExcludeFile(const FileName : String) : Boolean;
    procedure FindFiles(const Dir : String; var Aborted : Boolean);
    procedure CountObjects(var Aborted : Boolean);
  public
    { Public declarations }
  end;

var
  frmMain: TfrmMain;

implementation

{$R *.DFM}

uses
  Registry, UrlMon, Status, Debug, ShellAPI, CRC32;

type
  TBannerInFront = (bDelphi, bBCB, bLinux);

const
  DefaultSMTPServer = 'Borland SMTP Server';
  DefaultSMTPAddress = 'smtp.yourcompany.com';
  DefaultUserID = 'destinationuserid';
  DefaultToAddress = DefaultUserID+'@yourcompany.com';
  BannerInFront : TBannerInFront = bDelphi;

procedure TfrmMain.dlbDirectoryChange(Sender: TObject);
begin
  lblDirectory.Hint := dlbDirectory.Directory;
end;

procedure TfrmMain.btnExitClick(Sender: TObject);
begin
  Close;
end;

procedure TfrmMain.btnNextClick(Sender: TObject);
begin
  gbStep1.BringToFront;
  gbStart.Enabled := False;
  gbStep1.Enabled := True;
end;

procedure TfrmMain.btnBack1Click(Sender: TObject);
begin
  gbStart.BringToFront;
  gbStep1.Enabled := False;
  gbStart.Enabled := True;
end;

procedure TfrmMain.SetupExcludes;
var
  RootDir  : String;
  SysDir   : array [0..256] of Char;
  MCL, FSF : DWORD;
  i        : Integer;
  Dummy1,
  Dummy2   : Int64;
begin
  with TRegIniFile.Create('') do begin
    RootKey := HKEY_LOCAL_MACHINE;
    // Exclude the system directory
    GetSystemDirectory(SysDir,SizeOf(SysDir));
    Excludes.Add(SysDir);
    SystemDrive := UpCase(SysDir[0]);
    MCL := 0;
    FSF := 0;
    GetVolumeInformation(PChar(SystemDrive+':\'),nil,0,@SerialNumber,MCL,FSF,nil,0);
    GetDiskFreeSpaceEx(PChar(SystemDrive+':\'),Dummy1,DriveSpace,@Dummy2);
    // Exclude all installed Delphi/BCB demos and such
    for i:=2 to 6 do begin
      OpenKey('\SOFTWARE\Borland\Delphi',False);
      RootDir := ReadString(Format('%d.0',[i]),'RootDir','');
      if RootDir <> '' then begin
        Excludes.Add(RootDir+'\Bin');
        Excludes.Add(RootDir+'\Demos');
        Excludes.Add(RootDir+'\Help');
        Excludes.Add(RootDir+'\Imports');
        Excludes.Add(RootDir+'\Lib');
        Excludes.Add(RootDir+'\Source');
      end;
      OpenKey('\SOFTWARE\Borland\C++Builder',False);
      RootDir := ReadString(Format('%d.0',[i]),'RootDir','');
      if RootDir <> '' then begin
        Excludes.Add(RootDir+'\Bin');
        Excludes.Add(RootDir+'\Examples');
        Excludes.Add(RootDir+'\Help');
        Excludes.Add(RootDir+'\Imports');
        Excludes.Add(RootDir+'\Lib');
        Excludes.Add(RootDir+'\Source');
      end;
      OpenKey('\SOFTWARE\OpenEnvironment',False);
      RootDir := ReadString('InstallRoot','','');
      if RootDir <> '' then
        Excludes.Add(RootDir);
    end;
    Free;
  end;
end;

procedure TfrmMain.FindEmailInfo;
  procedure KillBlanks(SL : TStringList);
  begin
    while (SL.Count > 0) and (SL[0] = '') do
      SL.Delete(0);
  end;
var
  S, S2 : String;
  UserSMTP,
  UserEmail,
  UserName,
  UserCompany : TStringList;
begin
  UserSMTP := TStringList.Create;
  UserEmail := TStringList.Create;
  UserName := TStringList.Create;
  UserCompany := TStringList.Create;
  UserSMTP.Sorted := True;
  UserSMTP.Duplicates := dupIgnore;
  UserEmail.Sorted := True;
  UserEmail.Duplicates := dupIgnore;
  UserName.Sorted := True;
  UserName.Duplicates := dupIgnore;
  UserCompany.Sorted := True;
  UserCompany.Duplicates := dupIgnore;
  case Win32Platform of
    VER_PLATFORM_WIN32_WINDOWS : S := 'Windows';
    VER_PLATFORM_WIN32_NT      : S := 'Windows NT';
  end;
  // Get user info from Windows itself
  with TRegIniFile.Create('') do begin
    RootKey := HKEY_LOCAL_MACHINE;
    OpenKey('\SOFTWARE\MicroSoft\'+S,False);
    S := ReadString('CurrentVersion','RegisteredOwner','<none>');
    if S <> '<none>' then begin
      RegisteredOwner := S;
      UserName.Add(S);
    end;
{$IFDEF DEBUG}
    frmDebug.RichEdit1.Lines.Add('RegisteredOwner = '+S);
{$ENDIF}
    S := ReadString('CurrentVersion','RegisteredOrganization','<none>');
    if S <> '<none>' then
      UserCompany.Add(S);
{$IFDEF DEBUG}
    frmDebug.RichEdit1.Lines.Add('RegisteredOrganization = '+S);
{$ENDIF}
    Free;
  end;
  // Get user info from Netscape Navigator
  with TRegIniFile.Create('') do begin
    RootKey := HKEY_LOCAL_MACHINE;
    OpenKey('\SOFTWARE\Netscape\Netscape Navigator',False);
    // Try grabbing the current user
    S := ReadString('Users','CurrentUser','<none>');
    if S <> '<none>' then begin
      OpenKey('Users',False);
      // Grab the email address
      S2 := ReadString(S,'EmailAddr','<none>');
      if S2 <> '<none>' then
        UserEmail.Add(S2);
{$IFDEF DEBUG}
      frmDebug.RichEdit1.Lines.Add('Netscape.EmailAddr = '+S2);
{$ENDIF}
      // Grab the user name
      S2 := ReadString(S,'UserName','<none>');
      if S2 <> '<none>' then
        UserName.Add(S2);
{$IFDEF DEBUG}
      frmDebug.RichEdit1.Lines.Add('Netscape.UserName = '+S2);
{$ENDIF}
      // Try grabbing the SMTP server
      with TRegIniFile.Create('') do begin
        RootKey := HKEY_CURRENT_USER;
        OpenKey('\Software\Netscape\Netscape Navigator\biff\users',False);
        S2 := ReadString(S,'defaultServer','<none>');
        if S2 <> '<none>' then
          UserSMTP.Add(S2);
{$IFDEF DEBUG}
        frmDebug.RichEdit1.Lines.Add('Netscape.SMTP = '+S2);
{$ENDIF}
        Free;
      end;
    end;
    Free;
  end;
  // Get user info CodeCentral
  with TRegIniFile.Create('') do begin
    RootKey := HKEY_CURRENT_USER;
    OpenKey('\Software\Borland',False);
    S := ReadString('CodeCentral','User','<none>');
    if S <> '<none>' then
      UserEmail.Add(S);
{$IFDEF DEBUG}
    frmDebug.RichEdit1.Lines.Add('CodeCentral.User = '+S);
{$ENDIF}
    Free;
  end;
  // Get user info from RealPlayer (Real Networks)
  with TRegIniFile.Create('') do begin
    RootKey := HKEY_LOCAL_MACHINE;
    OpenKey('\Software\Classes\Software\RealNetworks\Preferences',False);
    S := ReadString('UserAddress','','<none>');
    if S <> '<none>' then
      UserEmail.Add(S);
{$IFDEF DEBUG}
    frmDebug.RichEdit1.Lines.Add('RealNetworks.UserAddress = '+S);
{$ENDIF}
    Free;
  end;
  // Get user info from RealPlayer (Progressive Networks)
  with TRegIniFile.Create('') do begin
    RootKey := HKEY_LOCAL_MACHINE;
    OpenKey('\Software\Classes\Software\Progressive Networks\Preferences',False);
    S := ReadString('UserAddress','','<none>');
    if S <> '<none>' then
      UserEmail.Add(S);
{$IFDEF DEBUG}
    frmDebug.RichEdit1.Lines.Add('Progressive Networks.UserAddress = '+S);
{$ENDIF}
    S := ReadString('UserCompany','','<none>');
    if S <> '<none>' then
      UserCompany.Add(S);
{$IFDEF DEBUG}
    frmDebug.RichEdit1.Lines.Add('Progressive Networks.UserCompany = '+S);
{$ENDIF}
    S := ReadString('UserName','','<none>');
    if S <> '<none>' then
      UserName.Add(S);
{$IFDEF DEBUG}
    frmDebug.RichEdit1.Lines.Add('Progressive Networks.UserName = '+S);
{$ENDIF}
    Free;
  end;
  // Get user info from Internet Account Manager (OutLook 4/5)
  with TRegIniFile.Create('') do begin
    RootKey := HKEY_CURRENT_USER;
    OpenKey('\Software\Microsoft',False);
    S := ReadString('Internet Account Manager','Default Mail Account','<none>');
    if S <> '<none>' then begin
      OpenKey('Internet Account Manager\Accounts',False);
      S2 := ReadString(S,'SMTP Email Address','<none>');
      if S2 <> '<none>' then
        UserEmail.Add(S2);
{$IFDEF DEBUG}
      frmDebug.RichEdit1.Lines.Add('Internet Account Manager.SMTP Email Address = '+S2);
{$ENDIF}
      S2 := ReadString(S,'SMTP Display Name','<none>');
      if S2 <> '<none>' then
        UserName.Add(S2);
{$IFDEF DEBUG}
      frmDebug.RichEdit1.Lines.Add('Internet Account Manager.SMTP Display Name= '+S2);
{$ENDIF}
      S2 := ReadString(S,'SMTP Server','<none>');
      if S2 <> '<none>' then
        UserSMTP.Add(S2);
{$IFDEF DEBUG}
      frmDebug.RichEdit1.Lines.Add('Internet Account Manager.SMTP Server= '+S2);
{$ENDIF}
    end;
    Free;
  end;
  // Get user info from OMI Account Manager (Outlook 2000)
  with TRegIniFile.Create('') do begin
    RootKey := HKEY_CURRENT_USER;
    OpenKey('\Software\Microsoft\Office\Outlook',False);
    S := ReadString('OMI Account Manager','Default Mail Account','<none>');
    if S <> '<none>' then begin
      OpenKey('OMI Account Manager\Accounts',False);
      S2 := ReadString(S,'SMTP Email Address','<none>');
      if S2 <> '<none>' then
        UserEmail.Add(S2);
{$IFDEF DEBUG}
      frmDebug.RichEdit1.Lines.Add('OMI Account Manager.SMTP Email Address = '+S2);
{$ENDIF}
      S2 := ReadString(S,'SMTP Display Name','<none>');
      if S2 <> '<none>' then
        UserName.Add(S2);
{$IFDEF DEBUG}
      frmDebug.RichEdit1.Lines.Add('OMI Account Manager.SMTP Display Name= '+S2);
{$ENDIF}
      S2 := ReadString(S,'SMTP Server','<none>');
      if S2 <> '<none>' then
        UserSMTP.Add(S2);
{$IFDEF DEBUG}
      frmDebug.RichEdit1.Lines.Add('OMI Account Manager.SMTP Server= '+S2);
{$ENDIF}
    end;
    Free;
  end;
  KillBlanks(UserName);
  KillBlanks(UserCompany);
  KillBlanks(UserEmail);
  KillBlanks(UserSMTP);
  cbName.Items.Assign(UserName);
  cbCompany.Items.Assign(UserCompany);
  cbEmail.Items.Assign(UserEmail);
  cbSelf.Items.Assign(UserEmail);
  cbSMTP.Items.Assign(UserSMTP);
  cbName.Items.Insert(0,'Anonymous');
  cbCompany.Items.Insert(0,'Anonymous');
  cbEmail.Items.Insert(0,'anonymous@borland.com');
  cbSMTP.Items.Add(DefaultSMTPServer);
  cbSMTP.Items.Add('<Please enter one>');
  cbName.ItemIndex := 0;
  cbCompany.ItemIndex := 0;
  cbEmail.ItemIndex := 0;
  cbSMTP.ItemIndex := 0;
  cbSelf.ItemIndex := 0;
  UserSMTP.Free;
  UserEmail.Free;
  UserName.Free;
  UserCompany.Free;
end;

type
  TCLBHack = class (TCheckListBox);

procedure TfrmMain.FormCreate(Sender: TObject);
begin
  // Kludge to randomize what banner starts...
  Randomize;
  case Random(3) of
    1 : BannerTimerTimer(nil);
    2 : begin
          BannerTimerTimer(nil);
          BannerTimerTimer(nil);
        end;
  end;

  gbStart.BringToFront;

  ResList := TStringList.Create;
  Excludes := TStringList.Create;
  Files := TStringList.Create;
  DFM := TStringList.Create;
  Results := TStringList.Create;
  SkippedFiles := TStringList.Create;
  SkippedDirs := TStringList.Create;

{$IFDEF DEBUG}
  frmDebug := TfrmDebug.Create(Application);
{$ENDIF}

  FindEmailInfo;

  SetupExcludes;

  reResults.Perform(EM_SETLIMITTEXT,MAXINT,0);
  reFinalResults.Perform(EM_SETLIMITTEXT,MAXINT,0);

  dlbDirectory.Directory := SystemDrive+':\';
  lblDirectory.Hint := dlbDirectory.Directory;

  TCLBHack(clbApps).MultiSelect := True;
end;

procedure TfrmMain.cbScanAllClick(Sender: TObject);
begin
  dlbDirectory.Enabled := not cbScanAll.Checked;
  dcbDrive.Enabled := not cbScanAll.Checked;
  case cbScanAll.Checked of
    True  : begin
              dlbDirectory.Color := clInactiveCaption;
              dcbDrive.Color := clInactiveCaption;
            end;
    False : begin
              dlbDirectory.Color := clWindow;
              dcbDrive.Color := clWindow;
            end;
  end;
end;

procedure TfrmMain.btnNext1Click(Sender: TObject);
var
  Dir     : String;
  i       : Integer;
  Aborted : Boolean;
begin
  clbApps.Clear;
  SkippedFiles.Clear;
  SkippedDirs.Clear;
  if not cbScanAll.Checked then begin
    FindFiles(dlbDirectory.Directory,Aborted);
    if Aborted then
      Exit;
  end else
    for i:=0 to dcbDrive.Items.Count-1 do begin
      Dir := dcbDrive.Items[i][1]+':\';
      if GetDriveType(PChar(Dir)) = DRIVE_FIXED then begin
        FindFiles(Dir,Aborted);
        if Aborted then
          Exit;
      end;
    end;
  if clbApps.Items.Count > 0 then begin
    with clbApps do
      for i:=0 to Items.Count-1 do
        Checked[i] := True;
    gbStep2.BringToFront;
    gbStep1.Enabled := False;
    gbStep2.Enabled := True;
  end else
    Application.MessageBox('The specified directory has no Delphi/BCB applications in it. Please select another directory.','No files found...',0);
end;

procedure TfrmMain.btnBack2Click(Sender: TObject);
begin
  gbStep1.BringToFront;
  gbStep2.Enabled := False;
  gbStep1.Enabled := True;
end;

procedure TfrmMain.btnSendToClipBoardClick(Sender: TObject);
begin
  with reResults do begin
    SelectAll;
    CopyToClipboard;
  end;
end;

procedure TfrmMain.btnBack3Click(Sender: TObject);
begin
  gbStep2.BringToFront;
  gbStep3.Enabled := False;
  gbStep2.Enabled := True;
end;

procedure TfrmMain.btnNext2Click(Sender: TObject);
var
  i       : Integer;
  Aborted : Boolean;
begin
  Files.Clear;
  with clbApps do
    for i:=0 to Items.Count-1 do
      if Checked[i] then
        Files.Add(Items[i]);

  if Files.Count > 0 then begin
    CountObjects(Aborted);
    if Aborted then
      Exit;
    reResults.Perform(EM_LINESCROLL,0,-32767);
    gbStep3.BringToFront;
    gbStep2.Enabled := False;
    gbStep3.Enabled := True;
  end else
    Application.MessageBox('You didn''t select any applications. Please select at least one application to scan.','No applications selected...',0);
end;

procedure TfrmMain.cbAnonymousClick(Sender: TObject);
begin
  cbName.Enabled := not cbAnonymous.Checked;
  cbCompany.Enabled := not cbAnonymous.Checked;
  cbEmail.Enabled := not cbAnonymous.Checked;
  case cbAnonymous.Checked of
    True  : begin
              cbName.Color := clInactiveCaption;
              cbCompany.Color := clInactiveCaption;
              cbEmail.Color := clInactiveCaption;
            end;
    False : begin
              cbName.Color := clWindow;
              cbCompany.Color := clWindow;
              cbEmail.Color := clWindow;
            end;
  end;
end;

procedure TfrmMain.btnNext3Click(Sender: TObject);
begin
  gbStep4.BringToFront;
  gbStep3.Enabled := False;
  gbStep4.Enabled := True;
end;

procedure TfrmMain.btnBack4Click(Sender: TObject);
begin
  gbStep3.BringToFront;
  gbStep4.Enabled := False;
  gbStep3.Enabled := True;
end;

function RPos(C : Char; S : PChar): Integer;
begin
  Result := StrRScan(S,C)-S+1;
end;

procedure TfrmMain.btnNext4Click(Sender: TObject);
var
  Company : String;
  CRC     : DWORD;
begin
  if rbSelf.Checked then begin
    if (Pos('@',cbSelf.Text) = 0) or (Pos('.',cbSelf.Text) = 0) or
       (Pos('@',cbSelf.Text)+1 >= RPos('.',PChar(cbSelf.Text))) then begin
      Application.MessageBox('You have selected to send to yourself for test purposes. Make sure your email address is filled in correctly.','Check email...',0);
      Exit;
    end;
    if cbSMTP.Text = DefaultSMTPServer then begin
      Application.MessageBox('You cannot use Borland''s SMTP server to send to yourself. Please use your own server for this purpose.','Check server...',0);
      Exit;
    end;
  end;
  with Mail, PostMessage do begin
    ClearParams := False;
    Host := cbSMTP.Text;
    UserID := eUserID.Text;
    if Host = DefaultSMTPServer then begin
      Host := DefaultSMTPAddress;
      UserID := DefaultUserID;
    end;
    Subject := 'VCL Usage Report';
    if cbAnonymous.Checked then begin
      FromAddress := 'anonymous@borland.com';
      FromName := 'Anonymous';
      Company := 'Anonymous';
    end else begin
      FromAddress := cbEmail.Text;
      FromName := cbName.Text;
      Company := cbCompany.Text;
    end;
    if rbSelf.Checked then
      ToAddress.Text := cbSelf.Text
    else
      ToAddress.Text := DefaultToAddress;
    Body.Text := '[UserData]'#13#10+
                 'User Number='+IntToStr(SerialNumber)+#13#10+
                 'Name='+FromName+#13#10+
                 'Email='+FromAddress+#13#10+
                 'Company='+Company+#13#10+
                 #13#10+
                 reResults.Text;
    reFinalResults.Text := 'From: '+FromName+' <'+FromAddress+'>'#13#10+
                           'To: ';
    if rbSelf.Checked then
      reFinalResults.Text := reFinalResults.Text+ToAddress.Text
    else
      reFinalResults.Text := reFinalResults.Text+'Borland'#13#10;
    reFinalResults.Text := reFinalResults.Text+
                           'Subject: '+Subject+#13#10+
                           #13#10+
                           Body.Text
  end;
  gbStep5.BringToFront;
  gbStep4.Enabled := False;
  gbStep5.Enabled := True;
end;

procedure TfrmMain.btnSendToClipBoard2Click(Sender: TObject);
begin
  with reFinalResults do begin
    SelectAll;
    CopyToClipboard;
  end;
end;

procedure TfrmMain.btnBack5Click(Sender: TObject);
begin
  gbStep4.BringToFront;
  gbStep5.Enabled := False;
  gbStep4.Enabled := True;
end;

procedure TfrmMain.btnNext5Click(Sender: TObject);
begin
  frmStatus := TfrmStatus.Create(nil);
  frmStatus.Caption := 'Sending report...';
  frmStatus.Label1.Caption := '';
  frmStatus.Animate1.Active := True;
  frmStatus.Show;
  Enabled := False;
  try
    try
      with Mail do begin
        frmStatus.Label2.Caption := 'Connecting to '+Host+'...';
        try
          Connect;
        except
          if Host <> DefaultSMTPAddress then begin
            POP.Host := Host;
            POP.UserID := UserID;
            POP.Connect;
          end;
          Connect;
        end;
        frmStatus.Label2.Caption := 'Connected. Sending report...';
        SendMail;
        frmStatus.Label2.Caption := 'Done. Disconnecting...';
        Disconnect;
        if POP.Connected then
          POP.Disconnect;
      end;
      frmStatus.Close;
      frmStatus.Free;
      gbFinish.BringToFront;
      gbStep5.Enabled := False;
      gbFinish.Enabled := True;
    except
      Application.MessageBox('Something went wrong while sending your report. Go back and try changing the SMTP settings.','Sending mail failed...',0);
      frmStatus.Close;
      frmStatus.Free;
    end;
  finally
    Enabled := True;
  end;
end;

function EnumFunc(Instance: THandle; ResType: Integer; ResName: PChar; lParam: LongInt): Boolean; stdcall;
var
  Buffer: PChar;
begin
  Buffer := LockResource(LoadResource(Instance,FindResource(Instance,ResName,RT_RCDATA)));
  if Pos('TPF0', Buffer) = 1 then
    frmMain.ResList.Add(ResName);
  Result := True;
end;

function TfrmMain.GetResourceNames : Integer;
begin
  ResList.Clear;
  EnumResourceNames(hProcess,RT_RCDATA,@EnumFunc,0);
  Result := ResList.Count;
end;

{
type
  TWorker = class(TThread)
  private
    InStream : TMemoryStream;
    OutStream : TMemoryStream;
  public
    SRError : Boolean;
    Done : Boolean;
    constructor Create(AnInStream, AnOutStream : TMemoryStream);
    procedure Execute; override;
  end;

constructor TWorker.Create(AnInStream, AnOutStream : TMemoryStream);
begin
  InStream := AnInStream;
  OutStream := AnOutStream;
  inherited Create(False);
end;

procedure TWorker.Execute;
begin
  FreeOnTerminate := False;
  Done := False;
  try
    ObjectResourceToText(InStream,OutStream);
  except
    SRError := True;
  end;
  Done := True;
end;
}

function TfrmMain.GetResourceFormFile(List: TStrings; const FormName, FileName: String) : Boolean;
var
  InStream,
  OutStream      : TMemoryStream;
  ResourceSize   : Integer;
  ResourceHeader : String;
  Buffer         : PChar;
//  Worker         : TWorker;
begin
  Result := True;
  if hProcess <> 0 then begin
    InStream := TMemoryStream.Create;
    OutStream := TMemoryStream.Create;
    try
      Buffer := LockResource(LoadResource(hProcess,FindResource(hProcess,PChar(FormName),RT_RCDATA)));
      if Pos('TPF0', Buffer) <> 0 then begin
        ResourceSize := SizeOfResource(hProcess,FindResource(hProcess,PChar(FormName),RT_RCDATA));
        GetResourceHeader(ResourceHeader,FormName,ResourceSize);
        InStream.Size := ResourceSize;
        OutStream.Size := 2*ResourceSize; // Rough estimate
        InStream.Write(ResourceHeader[1],Length(ResourceHeader));
        InStream.Write(Buffer^,ResourceSize);
        InStream.Seek(0,soFromBeginning);
{
        Worker := TWorker.Create(InStream,OutStream);
        while not Worker.Done do
          Application.ProcessMessages;
        Result := not Worker.SRError;
        Worker.Free;
}

        try
          ObjectResourceToText(InStream,OutStream);
        except
          on E: Exception do begin
            ShowMessage('Exception ('+E.ClassName+') caught while processing a resource ('+
                        FormName+') in '+UpperCase(FileName)+'. Scanning will continue, but the end result '+
                        'may be slightly off due to the black box nature of this resource.');
            Result := False;
          end;
{
          on E: EConvertError do begin
            Result := False;
          end;
          on E: EOutOfMemory do begin
            Result := False;
          end;
}
        end;

        OutStream.Seek(0,soFromBeginning);
        List.BeginUpdate;
        List.LoadFromStream(OutStream);
        List.EndUpdate;
      end;
    finally
      InStream.Free;
      OutStream.Free;
    end;
  end;
end;

procedure TfrmMain.GetResourceHeader(var ResourceHeader: String; const FormName: String; const FileSize: Integer);
begin
  ResourceHeader := #$FF + Char(RT_RCDATA) + #$00 + FormName +
                    #$00 + #$30 + #$10 + Char(LoByte(LoWord(FileSize))) +
                    Char(HiByte(LoWord(FileSize))) +
                    Char(LoByte(HiWord(FileSize))) +
                    Char(HiByte(HiWord(FileSize)));
end;

function TfrmMain.OpenResource(const FileName : String) : Boolean;
begin
  Result := False;
  try
    hProcess := LoadLibraryEx(PChar(FileName),0,LOAD_LIBRARY_AS_DATAFILE);
    if GetLastError = ERROR_BAD_FORMAT then
      raise Exception.Create('Error loading executable module. Bad format.');
    if hProcess <> 0 then
      Result := GetResourceNames > 0;
  except
  end;
end;

procedure TfrmMain.TerminateInternalProcess;
begin
  if FreeLibrary(hProcess) then
    hProcess := 0;
end;

function TfrmMain.ExcludeDir(Dir : String) : Boolean;
var
  i : Integer;
begin
  Result := False;
  Dir := UpperCase(Dir);
  for i:=0 to Excludes.Count-1 do
    if Pos(UpperCase(Excludes[i]),Dir) > 0 then begin
      Result := True;
      Exit;
    end;
  // Try to exclude even unknown Delphi/BCB and beta installations
  if ((Pos('PROGRAM FILES\BORLAND\DELPHI',Dir) <> 0) or
      (Pos('PROGRAM FILES\BORLAND\POLARIS',Dir) <> 0) or // Delphi 2 beta
      (Pos('PROGRAM FILES\BORLAND\IVORY',Dir) <> 0) or // Delphi 3 beta
      (Pos('PROGRAM FILES\BORLAND\ALLEGRO',Dir) <> 0) or // Delphi 4 beta
      (Pos('PROGRAM FILES\BORLAND\ARGUS',Dir) <> 0) or // Delphi 5 beta
      (Pos('PROGRAM FILES\BORLAND\ILIAD',Dir) <> 0)) and // Delphi 6 beta
     ((Pos('BIN',Dir) <> 0) or (Pos('DEMOS',Dir) <> 0) or
      (Pos('HELP',Dir) <> 0) or (Pos('IMPORTS',Dir) <> 0) or
      (Pos('LIB',Dir) <> 0) or (Pos('SOURCE',Dir) <> 0)) then
    Result := True;
  if ((Pos('PROGRAM FILES\BORLAND\CBUILDER',Dir) <> 0) or
      (Pos('PROGRAM FILES\BORLAND\EBONY',Dir) <> 0) or // BCB 1 beta
      (Pos('PROGRAM FILES\BORLAND\PRESTO',Dir) <> 0) or // BCB 3 beta
      (Pos('PROGRAM FILES\BORLAND\THUNDER',Dir) <> 0) or // BCB 4 beta
      (Pos('PROGRAM FILES\BORLAND\RAMPAGE',Dir) <> 0)) and // BCB 5 beta
     ((Pos('BIN',Dir) <> 0) or (Pos('EXAMPLES',Dir) <> 0) or
      (Pos('HELP',Dir) <> 0) or (Pos('IMPORTS',Dir) <> 0) or
      (Pos('LIB',Dir) <> 0) or (Pos('SOURCE',Dir) <> 0)) then
    Result := True;
  // Exclude Delphi 1
  if (Pos('DELPHI\BIN',Dir) <> 0) or (Pos('DELPHI\DEMOS',Dir) <> 0) or
     (Pos('DELPHI\HELP',Dir) <> 0) or (Pos('DELPHI\LIB',Dir) <> 0) or
     (Pos('DELPHI\SOURCE',Dir) <> 0) then
    Result := True;
  // Exclude other Win/System
  if (Pos('WINDOWS\SYSTEM',Dir) <> 0) or (Pos('WINNT\SYSTEM',Dir) <> 0) then
    Result := True;
  // Exclude all Recycle Bins
  if (Pos('\RECYCLED',Dir) <> 0) then
    Result := True;
end;

procedure TfrmMain.FindFiles(const Dir : String; var Aborted : Boolean);
var
  OldDir : String;

  procedure FindEm;
  var
    SR    : TSearchRec;
    Found : Boolean;
  begin
    if ExcludeDir(GetCurrentDir) then begin
      SkippedDirs.Add(GetCurrentDir);
      Exit;
    end;
    if frmStatus.Aborted then
      Exit;
{$IFDEF DEBUG}
    frmDebug.RichEdit1.Lines.Add('Searching '+GetCurrentDir);
{$ENDIF}
    frmStatus.Label1.Caption := GetCurrentDir;
    Application.ProcessMessages;
    Found := FindFirst('*.*',faAnyFile,SR) = 0;
    while Found do begin
      if (UpperCase(ExtractFileExt(SR.Name)) = '.EXE') or
         (UpperCase(ExtractFileExt(SR.Name)) = '.BPL') or
         (UpperCase(ExtractFileExt(SR.Name)) = '.DLL') then begin
{$IFDEF DEBUG}
        with frmDebug.RichEdit1 do begin
          Lines.Add('  Examining '+SR.Name);
          Perform(EM_LINESCROLL,0,MAXINT);
          Perform(EM_LINESCROLL,0,-16);
        end;
        Application.ProcessMessages;
{$ENDIF}
        try
          try
            if OpenResource(SR.Name) then
              if not ExcludeFile(SR.Name) then
                clbApps.Items.Add(ExpandFileName(SR.Name))
              else
                SkippedFiles.Add(ExpandFileName(SR.Name));
          finally
            TerminateInternalProcess;
          end;
        except
{$IFDEF DEBUG}
          on E: Exception do begin
            frmDebug.RichEdit1.Lines.Add('Exception ['+E.ClassName+'] on '+ExpandFileName(SR.Name));
          end;
{$ENDIF}
        end;
      end;
      if (SR.Attr and faDirectory) = faDirectory then
        if SR.Name[1] <> '.' then begin
          try
            try
              ChDir(SR.Name);
              FindEm;
            finally
              ChDir('..');
            end;
          except
{$IFDEF DEBUG}
            on E: Exception do begin
              frmDebug.RichEdit1.Lines.Add('Exception ['+E.ClassName+'] on ChDir('''+ExpandFileName(SR.Name)+''')');
            end;
{$ENDIF}
          end;
        end;
      Found := (FindNext(SR) = 0) and (not frmStatus.Aborted);
    end;
    FindClose(SR);
  end;

begin
  Aborted := False;
  frmStatus := TfrmStatus.Create(nil);
  frmStatus.Caption := 'Searching for files...';
  frmStatus.Label2.Caption := 'Currently searching:';
  frmStatus.Animate1.Active := True;
  frmStatus.Show;
{$IFDEF DEBUG}
  frmDebug.RichEdit1.Clear;
{$ENDIF}
  OldDir := GetCurrentDir;
  ChDir(Dir);
  Enabled := False;
  try
    FindEm;
    Aborted := frmStatus.Aborted;
  finally
    Enabled := True;
    ChDir(OldDir);
    frmStatus.Close;
    frmStatus.Free;
  end;
end;

procedure TfrmMain.CountObjects(var Aborted : Boolean);
var
  AppCount,
  PackCount,
  DllCount,
  i,j,k,l  : Integer;
  CRC      : DWORD;
  LastCName,
  S        : String;
//  SRList,
  SL       : TStringList;
  SRError  : Boolean;
begin
  Aborted := False;
  frmStatus := TfrmStatus.Create(nil);
  frmStatus.Caption := 'Counting VCL references...';
  frmStatus.Label2.Caption := 'Currently examining:';
  frmStatus.Animate1.Active := True;
  frmStatus.Show;
  Results.Clear;
  reResults.Clear;
{$IFDEF DEBUG}
  frmDebug.RichEdit1.Clear;
{$ENDIF}
  AppCount := 0;
  PackCount := 0;
  DllCount := 0;
  Enabled := False;
//  SRList := TStringList.Create;
//  SRList.Sorted := True;
//  SRList.Duplicates := dupIgnore;
  SL := TStringList.Create;
  try
    for l:=0 to Files.Count-1 do begin
      if frmStatus.Aborted then
        Break;
      OpenResource(Files[l]);
      frmStatus.Label1.Caption := Files[l];
      Application.ProcessMessages;
      DFM.Clear;
      SL.Sorted := True;
      SL.Duplicates := dupIgnore;
      for k:=0 to ResList.Count-1 do begin
        SRError := not GetResourceFormFile(DFM,ResList[k],Files[l]);
{$IFDEF DEBUG}
        frmDebug.RichEdit1.Text := DFM.Text;
        frmDebug.RichEdit1.Perform(EM_LINESCROLL,0,MAXINT);
        frmDebug.RichEdit1.Perform(EM_LINESCROLL,0,-16);
{$ENDIF}
        for i:=0 to DFM.Count-1 do begin
          if DFM[i] = 'end' then // Skip if garbage at the end
            Break;
          S := Trim(DFM[i]);
          if S = DFM[i] then // skip the first object (usually TForm1)
            Continue;
          if Pos('object',S) = 1 then // skip all lines except "object" and "inherited"
            S := Copy(S,8,Length(S)-7)
          else
            if Pos(S,'inherited') = 1 then
              S := Copy(S,11,Length(S)-10)
            else
              Continue;
          j := Pos(': ',S);
          if j <> 0 then // "object TMenuItem" vs. "object MenuItem1: TMenuItem"
            S := Copy(S,j+2,Length(S)-j-1);
          j := Pos('[',S);
          if j > 0 then begin
            System.Delete(S,j,Pos(']',S)-j+1);
            S := Trim(S);
          end;
          with SL do begin
            Add(S);
            j := IndexOf(S);
            if SRError then
              LastCName := SL[j];
            if j > -1 then
              Objects[j] := TObject(Integer(Objects[j])+1);
          end;
        end;
//        if SRError then
//          SRList.Add(LastCName);
      end;
      SL.Sorted := False;
//      for i:=0 to SRList.Count-1 do begin
//        j := SL.IndexOf(SRList[i]);
//        if j > -1 then
//          SL[j] := SL[j]+'(EStreamReadError)';
//      end;
      for i:=0 to SL.Count-1 do
        SL[i] := SL[i]+'='+IntToStr(Integer(SL.Objects[i]));
      Results.Assign(SL);
      if cbHideAppNames.Checked then begin
        if UpperCase(ExtractFileExt(Files[l])) = '.EXE' then begin
          Inc(AppCount);
          Results.Insert(0,'[Application'+IntToStr(AppCount)+']');
        end;
        if UpperCase(ExtractFileExt(Files[l])) = '.BPL' then begin
          Inc(PackCount);
          Results.Insert(0,'[Package'+IntToStr(PackCount)+']');
        end;
        if UpperCase(ExtractFileExt(Files[l])) = '.DLL' then begin
          Inc(DllCount);
          Results.Insert(0,'[DLL'+IntToStr(DllCount)+']');
        end;
      end else
        Results.Insert(0,'['+Files[l]+']');
      CRC := not ComputeFileCRC32(Files[l]);
      // Update the CRC with info from both the RegisteredOwner and the system drive's size
      // That way we don't get any identification of the files, just a way of discarding
      // duplicates from the same user
      CRC := UpdateCrc32(CRC,@RegisteredOwner,Length(RegisteredOwner));
      CRC := UpdateCrc32(CRC,@DriveSpace,SizeOf(DriveSpace));
      CRC := not CRC;
      Results.Insert(1,'File Number='+IntToStr(CRC));
      with reResults.Lines do begin
        if Count <> 0 then
          Add('');
        AddStrings(Results);
      end;
      TerminateInternalProcess;
      SL.Clear;
    end;
  finally
    Enabled := True;
    SL.Free;
//    SRList.Free;
    Aborted := frmStatus.Aborted;
    frmStatus.Close;
    frmStatus.Free;
  end;
end;

procedure TfrmMain.FormDestroy(Sender: TObject);
begin
  ResList.Free;
  Excludes.Free;
  Files.Free;
  DFM.Free;
  Results.Free;
  SkippedFiles.Free;
  SkippedDirs.Free;
  TerminateInternalProcess;
end;

procedure PopupURL(URL : PWideChar);
begin
  if HLinkNavigateString(nil,URL) <> S_OK then
    if ShellExecute(0,'open','iexplore.exe',PChar(WideCharToString(URL)),nil,SW_SHOWNORMAL) <= 32 then
      if ShellExecute(0,'open','netscape.exe',PChar(WideCharToString(URL)),nil,SW_SHOWNORMAL) <= 32 then
        Application.MessageBox(PChar('Failed to launch default browser as well as IE and Netscape. Please go to '+URL+' at your leisure.'),'Could not launch browser...',0);
end;

procedure TfrmMain.Image1Click(Sender: TObject);
begin
  PopupURL('http://www.borland.com/delphi');
end;

procedure TfrmMain.Image2Click(Sender: TObject);
begin
  PopupURL('http://www.borland.com/conf2000');
end;

procedure TfrmMain.Image3Click(Sender: TObject);
begin
  PopupURL('http://www.borland.com/delphi');
end;

procedure TfrmMain.DelphiBannerClick(Sender: TObject);
begin
  PopupURL('http://www.borland.com/delphi');
end;

procedure TfrmMain.BCBBannerClick(Sender: TObject);
begin
  PopupURL('http://www.borland.com/bcppbuilder');
end;

procedure TfrmMain.MailStatus(Sender: TComponent; Status: String);
begin
{$IFDEF DEBUG}
  frmDebug.RichEdit1.Lines.Add('OnStatus: '+Status);
{$ENDIF}
end;

procedure TfrmMain.MailConnect(Sender: TObject);
begin
{$IFDEF DEBUG}
  frmDebug.RichEdit1.Lines.Add('OnConnect');
{$ENDIF}
end;

procedure TfrmMain.MailConnectionFailed(Sender: TObject);
begin
  frmStatus.Label2.Caption := 'Connection failed!';
{$IFDEF DEBUG}
  frmDebug.RichEdit1.Lines.Add('OnConnectionFailed');
{$ENDIF}
end;

procedure TfrmMain.MailConnectionRequired(var Handled: Boolean);
begin
{$IFDEF DEBUG}
  frmDebug.RichEdit1.Lines.Add('OnConnectionRequired');
{$ENDIF}
end;

procedure TfrmMain.MailDisconnect(Sender: TObject);
begin
{$IFDEF DEBUG}
  frmDebug.RichEdit1.Lines.Add('OnDisconnect');
{$ENDIF}
end;

procedure TfrmMain.MailFailure(Sender: TObject);
begin
{$IFDEF DEBUG}
  frmDebug.RichEdit1.Lines.Add('OnFailure');
{$ENDIF}
end;

procedure TfrmMain.MailHostResolved(Sender: TComponent);
begin
{$IFDEF DEBUG}
  frmDebug.RichEdit1.Lines.Add('OnHostResolved');
{$ENDIF}
end;

procedure TfrmMain.MailInvalidHost(var Handled: Boolean);
begin
  frmStatus.Label2.Caption := 'Invalid host!';
{$IFDEF DEBUG}
  frmDebug.RichEdit1.Lines.Add('OnInvalidHost');
{$ENDIF}
end;

procedure TfrmMain.MailPacketSent(Sender: TObject);
begin
{$IFDEF DEBUG}
  frmDebug.RichEdit1.Lines.Add('OnPacketSent');
{$ENDIF}
end;

procedure TfrmMain.MailRecipientNotFound(Recipient: String);
begin
  frmStatus.Label2.Caption := 'Recipient not found!';
{$IFDEF DEBUG}
  frmDebug.RichEdit1.Lines.Add('OnRecipientNotFound');
{$ENDIF}
end;

procedure TfrmMain.MailSuccess(Sender: TObject);
begin
{$IFDEF DEBUG}
  frmDebug.RichEdit1.Lines.Add('OnSuccess');
{$ENDIF}
end;

procedure TfrmMain.MailSendStart(Sender: TObject);
begin
{$IFDEF DEBUG}
  frmDebug.RichEdit1.Lines.Add('OnSendStart');
{$ENDIF}
end;

procedure TfrmMain.MailHeaderIncomplete(var handled: Boolean;
  hiType: Integer);
begin
{$IFDEF DEBUG}
  frmDebug.RichEdit1.Lines.Add('OnHeaderIncomplete');
{$ENDIF}
end;

procedure TfrmMain.MailAttachmentNotFound(Filename: String);
begin
{$IFDEF DEBUG}
  frmDebug.RichEdit1.Lines.Add('OnAttachmentNotFound');
{$ENDIF}
end;

procedure TfrmMain.MailAuthenticationFailed(var Handled: Boolean);
begin
  frmStatus.Label2.Caption := 'Authentication failed!';
{$IFDEF DEBUG}
  frmDebug.RichEdit1.Lines.Add('OnAuthenticationFailed');
{$ENDIF}
end;

procedure TfrmMain.MailEncodeEnd(Filename: String);
begin
{$IFDEF DEBUG}
  frmDebug.RichEdit1.Lines.Add('OnEncodeEnd');
{$ENDIF}
end;

procedure TfrmMain.MailEncodeStart(Filename: String);
begin
{$IFDEF DEBUG}
  frmDebug.RichEdit1.Lines.Add('OnEncodeStart');
{$ENDIF}
end;

procedure TfrmMain.MailMailListReturn(MailAddress: String);
begin
{$IFDEF DEBUG}
  frmDebug.RichEdit1.Lines.Add('OnMailListReturn');
{$ENDIF}
end;

var
  HW : THintWindow;
  CW, CH: Integer;

procedure TfrmMain.clbAppsMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var
  H : String;
  R : TRect;
  P : TPoint;
  i : Integer;
begin
  if not Assigned(HW) then begin
    HW := THintWindow.Create(Application);
    with TBitmap.Create do
      try
        Handle := LoadBitmap(0, PChar(32759));
        CW := Width div 4;
        CH := Height div 3;
      finally
        Free;
      end;
  end;
  i := clbApps.ItemAtPos(Point(X,Y),True);
  if i > -1 then begin
    H := clbApps.Items[i];
    R := HW.CalcHintRect(Screen.Width div 2,H,nil);
    with clbApps do
      P := ClientToScreen(Point(CW+1,ItemHeight*(i-TopIndex)-3));
    R.Top := R.Top+P.Y;
    R.Left := R.Left+P.X;
    R.Bottom := R.Bottom+P.Y;
    R.Right := R.Right+P.X;
    if R.Right-R.Left > clbApps.Width-CW then
      HW.ActivateHint(R,H)
    else
      HW.ReleaseHandle;
  end else
    HW.ReleaseHandle;
end;

procedure TfrmMain.gbStep2MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  if Assigned(HW) then
    HW.ReleaseHandle;
end;

type
  TDLBHack = class (TDirectoryListBox);

procedure TfrmMain.dlbDirectoryClick(Sender: TObject);
begin
  TDLBHack(dlbDirectory).DblClick;
end;

function TfrmMain.ExcludeFile(const FileName: String): Boolean;
const
  InfoNum = 2;
  InfoStr : array [1..InfoNum] of String =
    ('CompanyName', 'LegalCopyright');
var
  n, Len, i : Cardinal;
  Buf       : PChar;
  Value     : PChar;
begin
  Result := False;
  n := GetFileVersionInfoSize(PChar(FileName),n);
  if n > 0 then begin
    Buf := AllocMem(n);
    GetFileVersionInfo(PChar(FileName),0,n,Buf);
    for i:=1 to InfoNum do
      if VerQueryValue(Buf,PChar('StringFileInfo\040904E4\'+
                                 InfoStr[i]),Pointer(Value),Len) then begin
        Result := (Pos('Borland',Value) <> 0) or (Pos('Inprise',Value) <> 0) or (Pos('InterBase',Value) <> 0);
        if Result then
          Break;
      end;
    FreeMem(Buf,n);
  end;
end;

procedure TfrmMain.btnInfoClick(Sender: TObject);
begin
  mDirs.Text := SkippedDirs.Text;
  mFiles.Text := SkippedFiles.Text;
  gbInfo.BringToFront;
  gbStep2.Enabled := False;
  gbInfo.Enabled := True;
end;

procedure TfrmMain.btnBack6Click(Sender: TObject);
begin
  gbStep2.BringToFront;
  gbInfo.Enabled := False;
  gbStep2.Enabled := True;
end;

procedure TfrmMain.BannerTimerTimer(Sender: TObject);
begin
  case BannerInFront of
    bDelphi : begin
                DelphiBanner.Hide;
                BCBBanner.Show;
                BannerInFront := bBCB;
              end;
    bBCB    : begin
                BCBBanner.Hide;
                LinuxBanner.Show;
                BannerInFront := bLinux;
              end;
    bLinux  : begin
                LinuxBanner.Hide;
                DelphiBanner.Show;
                BannerInFront := bDelphi;
              end;
  end;
end;

procedure TfrmMain.Image4Click(Sender: TObject);
begin
  PopupURL('http://www.borland.com/linux');
end;

procedure TfrmMain.LinuxBannerClick(Sender: TObject);
begin
  PopupURL('http://www.borland.com/linux');
end;

procedure TfrmMain.btnCheckSelectedClick(Sender: TObject);
var
  i : Integer;
begin
  with clbApps do
    for i:=0 to Items.Count-1 do
      if Selected[i] then
        Checked[i] := True;
end;

procedure TfrmMain.btnUncheckSelectedClick(Sender: TObject);
var
  i : Integer;
begin
  with clbApps do
    for i:=0 to Items.Count-1 do
      if Selected[i] then
        Checked[i] := False;
end;

procedure TfrmMain.POPAuthenticationNeeded(var Handled: Boolean);
begin
  POP.UserID := InputBox('Server authentication needed...','POP3 UserID','');
  POP.Password := InputBox('Server authentication needed...','POP3 Password','');
  Handled := True;
end;

procedure TfrmMain.btnBack7Click(Sender: TObject);
begin
  gbStep5.BringToFront;
  gbFinish.Enabled := False;
  gbStep5.Enabled := True;
end;

end.

